# std::perror

From cppreference.com
< cpp‎ | io‎ | c

Defined in header `<cstdio>` |  |
void perror( const char *s ); |  |

Prints a textual description of the error code currently stored in the system variable errno to stderr.

The description is formed by concatenating the following components:

- the contents of the null-terminated byte string pointed to by `s` (unless `s` is a null pointer)
- ": "
- implementation-defined error message describing the error code stored in `errno`. This message is identical to the output of std::strerror(errno).
- '\n'.

### Parameters

s | - | pointer to a null-terminated string with explanatory message

### Return value

(none)

### Example

Run this code

    #include <cmath>
    #include <cerrno>
    #include <cstdio>

    int main()
    {
        double not_a_number = std::log(-1.0);
        if (errno == EDOM) {
            std::perror("log(-1) failed");
        }
    }

Output:

    log(-1) failed: Numerical argument out of domain

### See also

errno | macro which expands to POSIX-compatible thread-local error number variable (macro variable)
strerror | returns a text version of a given error code (function)
C documentation for perror

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/io/c/perror&oldid=77080"